#!/bin/sh

# stuff for tracking test case counts
FAILS=0
OKS=0
TOTAL=0
LOG_DETAILS=

#relevant pids default vals
UTIL_PID=-1
MT_TEST=-1
LOGGER=-1

TEST_DYNAMIC_FILTERS="false"
TESTDIR=/var/lib/dlog-tests

extract_timestamp() {
	local ts=0
	case "$1" in
		"threadtime")
			time=`echo $2 | awk -F '[ +]' '{print $2}'`
			ts=`date +%s%N -d $time`
		;;
		"long")
			time=`echo $2 | awk -F '[ +.]' '{print $3}'`
			ms=`echo $2 | awk -F '[ +.]' '{print $4}'`
			sec=`date +%s%N -d $time`
			ns=$((10#$ms * 1000000))
			ts=$(($sec + $ns))
		;;
		"rwtime")
			time=`echo $2 | awk -F '[ +.]' '{print $2}'`
			ts=`date +%s%N -d $time`
		;;
		"recv_realtime")
			time=`echo $2 | awk -F '[ +.]' '{print $2}'`
			ts=`date +%s%N -d $time`
		;;
		"time")
			time=`echo $2 | awk -F '[ +.]' '{print $2}'`
			ts=`date +%s%N -d $time`
		;;
		"kerneltime")
			ts=`echo $2 | awk -F '[ +]' '{print $1}' | sed -e 's/\.//g'`
		;;
	esac
	echo "$ts"
}

cleanup() {
	[ $UTIL_PID -ne -1 ] && kill $UTIL_PID > /dev/null 2>&1
	[ $MT_TEST  -ne -1 ] && kill $MT_TEST  > /dev/null 2>&1
	[ $LOGGER   -ne -1 ] && kill $LOGGER   > /dev/null 2>&1
	[ -d $TESTDIR ] && rm -rf $TESTDIR/*
	[ -d $RUNTIME_FILTERS_DIR ] && rm -rf $RUNTIME_FILTERS_DIR
}

trap cleanup 0

check_daemon() {
	local ret=1
	if [ $LOGGER -ne -1 ] && [ -z "$(ps -o pid= -p $LOGGER)" ]; then
		ret=0
	fi
	return $ret
}

fail() {
	check_daemon
	[ $? -eq 0 ] && daemon_status="[logger daemon not running]"

	FAILS=$(($FAILS + 1))
	TOTAL=$(($TOTAL + 1))
	printf "[%02d] FAILED: %s %s\n" $TOTAL "$LOG_DETAILS" "$daemon_status"
	LOG_DETAILS=
}

ok() {
	check_daemon
	[ $? -eq 0 ] && daemon_status="[logger daemon not running]"

	OKS=$(($OKS + 1))
	TOTAL=$(($TOTAL + 1))
	printf "[%02d] PASSED: %s %s\n" $TOTAL "$LOG_DETAILS" "$daemon_status"
	LOG_DETAILS=
}

# supress stderr messages from subcommands
exec 2> /dev/null

if [ $# -ne 1 ]; then
	echo "usage: $0 pipe|logger"
	exit 1
fi

if [ "$1" == "pipe" ]; then
	type="pipe"
elif [ "$1" == "logger" ]; then
	type="logger"
else
	echo "usage: $0 pipe|logger"
	exit 1
fi

export DLOG_CONFIG_PATH="/usr/share/dlog-$type.conf.test"
PATH=$PATH:/usr/libexec/libdlog/

#create dir for runtime filters
RUNTIME_FILTERS_DIR="/tmp/dlog-filters/"
mkdir -p "$RUNTIME_FILTERS_DIR"

# Start the daemon
if [ $type == "pipe" ]; then
	dlog_logger -b 99 -t 0 &
	LOGGER=$!
	sleep 1
fi

# put 100 log entries in the "main" buffer
dlogutil -c
test_libdlog 100
sleep 1


LOG_DETAILS="testing if dlogutil -d exits with success after printing logs"
dlogutil -d &> /dev/null && ok || fail

LOG_DETAILS="testing if -t argument is parsed properly"
dlogutil -t dummy &> /dev/null && fail || ok

LOG_DETAILS="testing if -u argument is parsed properly"
dlogutil -du dummy &> /dev/null && fail || ok

LOG_DETAILS="testing if limiting printed log entries to less than exists in the buffer returns proper value"
[ $(dlogutil -b main -t  20 | wc -l) -eq  20 ] && ok || fail # less logs than currently in buffer

LOG_DETAILS="testing if limiting printed log entries to more than exists in the buffer returns proper value"
[ $(dlogutil -b main -t 200 | wc -l) -eq 100 ] && ok || fail # more

LOG_DETAILS="testing if dlogutil returns exact amount of entries as there is in the buffer"
[ $(dlogutil -b main -d     | wc -l) -eq 100 ] && ok || fail # exactly

LOG_DETAILS="testing if reading from  dummy buffer returns an error as expected"
dlogutil -b nonexistent_buffer &> /dev/null && fail || ok

LOG_DETAILS="testing if reading from \"system\" buffer returns zero entries (logs are in the \"main\" buffer)"
[ $(dlogutil -d -b system | wc -l) -eq 0 ] && ok || fail

LOG_DETAILS="testing if dlogutil -c empties all buffers"
dlogutil -c && ok || fail

LOG_DETAILS="testing if writing entries to empty buffer and reading them returns proper amount of entries"
test_libdlog 10
[ $(dlogutil -b main -d | wc -l) -eq 10 ] && ok || fail # should be 10, not 110

LOG_DETAILS="testing if filters work"
[ $(dlogutil -b main -d *:E | wc -l) -eq 5 ] && ok || fail # half of current logs (test_libdlog alternates between error and info log levels)

LOG_DETAILS="testing if adding \"silent\" filter works"
[ $(dlogutil -b main -s -d | wc -l) -eq 0 ] && ok || fail

LOG_DETAILS="testing if reading buffer size returns proper exit code"
dlogutil -g &> /dev/null && ok || fail

LOG_DETAILS="testing if writing all entries to single file works (-f)"
dlogutil -f $TESTDIR/dlog_test_file -d &> /dev/null && ok || fail

LOG_DETAILS="testing if writing entries to rotating files works (-r/-n)"
dlogutil -f $TESTDIR/dlog_rotating_file -r 12 -n 3 & # 3 files at 12 KB each
UTIL_PID=$!
test_libdlog 100000
sleep 1

LOG_DETAILS="testing if single file is properly created"
if [ -e $TESTDIR/dlog_test_file ]; then ok; else fail; fi

LOG_DETAILS="testing if rotating file is properly created (1/4)"
if [ -e $TESTDIR/dlog_rotating_file.1 ]; then ok; else fail; fi

LOG_DETAILS="testing if rotating file is properly created (2/4)"
if [ -e $TESTDIR/dlog_rotating_file.2 ]; then ok; else fail; fi

LOG_DETAILS="testing if rotating file is properly created (3/4)"
if [ -e $TESTDIR/dlog_rotating_file.3 ]; then ok; else fail; fi

LOG_DETAILS="testing if rotating file is properly created (4/4)"
if [ -e $TESTDIR/dlog_rotating_file.4 ]; then fail; else ok; fi

LOG_DETAILS="testing the size of log files"
if [ $(du $TESTDIR/dlog_rotating_file.3 | sed "s#$TESTDIR/dlog_rotating_file.3##g") -eq 16 ]; then ok; else fail; fi # the actual size is one sector more (so 12 -> 16) because the limit is checked after reaching it, not before

cmd="dlogutil -t 1 -v "

format="process"
regex_prio="[VDIWEFS]{1}"
regex_pidtid="P[0-9[:space:]]{5,},\s{1}T[0-9[:space:]]{5,}"
regex_time="[0-9]{2}-[0-9]{2}\s{1}[0-9]{2}:[0-9]{2}:[0-9]{2}"
regex_timezone="[\+-]{1}[0-9]{4}"

REGEX="s/^$regex_prio\([0-9[:space:]]{5,}\)[[:print:]]*\([[:print:]]*\)$/1/g"
LOG_DETAILS="testing if \"$format\" print format works"
line=`$cmd $format`
[[ `echo "$line" | sed -re $REGEX` == "1" ]] && ok || fail

format="tag"
REGEX="s/^$regex_prio\/[[:print:]]{9,}:\s{1}[[:print:]]*$/1/g"
LOG_DETAILS="testing if \"$format\" print format works"
line=`$cmd $format`
[[ `echo "$line" | sed -re $REGEX` == "1" ]] && ok || fail

format="thread"
REGEX="s/^$regex_prio\($regex_pidtid\)\s{1}[[:print:]]*$/1/g"
LOG_DETAILS="testing if \"$format\" print format works"
line=`$cmd $format`
[[ `echo "$line" | sed -re $REGEX` == "1" ]] && ok || fail

format="time"
REGEX="s/^$regex_time.[0-9]{3}$regex_timezone\s{1}$regex_prio\/[[:print:]]{8,}\([0-9[:space:]]{5,}\):\s{1}[[:print:]]*$/1/g"
LOG_DETAILS="testing if \"$format\" print format works"
line=`$cmd $format`
[[ `echo "$line" | sed -re $REGEX` == "1" ]] && ok || fail

format="threadtime"
REGEX="s/^$regex_time.[0-9]{3}$regex_timezone\s{1}$regex_prio\/[[:print:]]{8,}\($regex_pidtid\):\s{1}[[:print:]]*$/1/g"
LOG_DETAILS="testing if \"$format\" print format works"
line=`$cmd $format`
[[ `echo "$line" | sed -re $REGEX` == "1" ]] && ok || fail

format="kerneltime"
REGEX="s/^[0-9[:space:]]{1,}.[0-9]{3,}\s{1}$regex_prio\/[[:print:]]{8,}\($regex_pidtid\):\s{1}[[:print:]]*$/1/g"
LOG_DETAILS="testing if \"$format\" print format works"
line=`$cmd $format`
[[ `echo "$line" | sed -re $REGEX` == "1" ]] && ok || fail

format="recv_realtime"
REGEX="s/^$regex_time.[0-9]{3}\s{1}$regex_prio\/[[:print:]]{8,}\($regex_pidtid\):\s{1}[[:print:]]*$/1/g"
LOG_DETAILS="testing if \"$format\" print format works"
line=`$cmd $format`
[[ `echo "$line" | sed -re $REGEX` == "1" ]] && ok || fail

format="rwtime"
REGEX="s/^$regex_time\s{1}\[[0-9[:space:]]{3,}.[0-9[:space:]]{3,}\]\s{1}$regex_prio\/[[:print:]]{8,}\($regex_pidtid\):\s{1}[[:print:]]*$/1/g"
LOG_DETAILS="testing if \"$format\" print format works"
line=`$cmd $format`
[[ `echo "$line" | sed -re $REGEX` == "1" ]] && ok || fail

format="long"
REGEX="s/^\[\s{1}$regex_time.[0-9]{3,}\s{1}$regex_prio\/[[:print:]]{8,}\s{1}$regex_pidtid\]\s{1}[[:print:]]*$/1/g"
LOG_DETAILS="testing if \"$format\" print format works"
line=`$cmd $format`
[[ `echo "$line" | tr '\n' ' ' | sed -re $REGEX` == "1" ]] && ok || fail

format="brief"
REGEX="s/^$regex_prio\/[[:print:]]{8,}\([0-9[:space:]]{5,}\):\s{1}[[:print:]]*$/1/g"
LOG_DETAILS="testing if \"$format\" print format works"
line=`$cmd $format`
[[ `echo "$line" | sed -re $REGEX` == "1" ]] && ok || fail

format="raw"
LOG_DETAILS="testing if \"$format\" print format works"
dlogsend -b main -t DLOG_TESTSUITE rawformatTEST
line=`$cmd $format`
[[ "$line" == "rawformatTEST" ]] && ok || fail

LOG_DETAILS="testing if pid filtering works"
dlogsend -b main -t DLOG_TESTSUITE pidTEST &
sleep 1
line=`dlogutil -v raw -d --pid $!`
[[ "$line" == "pidTEST" ]] && ok || fail

LOG_DETAILS="testing if tid filtering works"
dlogsend -b main -t DLOG_TESTSUITE tidTEST &
sleep 1
line=`dlogutil -v raw -d --tid $!` #dlogsend is a single threaded app so tid is the same as pid
[[ "$line" == "tidTEST" ]] && ok || fail

if [ "$TEST_DYNAMIC_FILTERS" == "true" ]; then
	LOG_DETAILS="testing if limiter and runtime filtering works"
	dlogutil -c -b radio
	test_filters
	[ $(dlogutil -d -b radio | wc -l) -eq 12 ] && ok || fail
fi

LOG_DETAILS="testing if the library works with multithreaded app"
dlogutil -f $TESTDIR/dlog_mt_test &
MT_TEST=$!
test_libdlog && ok || fail

dlogutil -c
SPAWN_CNT=1000

# spawn logging scripts and wait for them to finish
for i in `seq 1 $SPAWN_CNT`; do
	delay=$(( (RANDOM) % 50 ))
	( sleep $delay && dlogsend -b main -t DLOG_TESTSUITE $delay ) &
done
sleep 60

sort_formats="kerneltime time recv_realtime rwtime threadtime long"

for format in $sort_formats; do
	LOG_DETAILS="testing if sorting by timestamp from random sources on heavy load works ($format format)"
	prev_ts=0
	unsorted=""
	prev_line=""

	# collect data and analyze timestamps
	lines=`dlogutil -b main -d -v $format`
	while read line; do
		# filter out empty lines in "long" format
		[ -z "$line" ] && continue
		# filter out non-timestamp lines in "long" format
		if [ $format == "long" ] && [ "`echo "$line" | sed -re s/^\[[[:print:]]*\]$/line_ok/g`" != "line_ok" ]; then
			continue
		fi

		[ "$line" -eq "$line" ] 2>/dev/null && continue

		ts=$(extract_timestamp "$format" "$line")

		if [ "$ts" -ge "$prev_ts" ]; then
			prev_ts=$ts
		else
			printf -v unsorted '%s\n\n%s\n%s' "$unsorted" "$prev_line" "$line"
			break
		fi
		prev_line=$line
	done <<< "$lines"

	[ -z "$unsorted" ] && ok || fail
done

# show results and clean up

echo "$OKS / $TOTAL tests passed"
echo "$FAILS / $TOTAL tests failed"
